%%%%%%
%%%%%   Make a FilterManager with classes in MATLAB
%%%%%
%
%   author: Emmanuel Roux (emmanuel.roux@creatis.insa-lyon.fr)
%
%   Date: 2016/04/29 
%
%% Add library
addpath(genpath('src'));

%% Input image
% Generate a random input image
I = randi(255,128,128);

%% Filtering pipeline
% Define the Filter Manager
FilterManager = ClassFilterManager;
% Set the input image 
FilterManager.SetInputImage(I);
% Filter the input image through the filter pipeline
FilterManager.Process;

%% Show the processed image
% Get the result
I_out = FilterManager.GetResult;
% display final image
figure;subplot(1,2,1);
imagesc(I);
title('INPUT image');
subplot(1,2,2);
imagesc(I_out);
title('OUTPUT image');