classdef (Abstract) ClassBaseFilter < handle
% ClassBaseFilter
%
%   author: Emmanuel Roux (emmanuel.roux@creatis.insa-lyon.fr)
%
%   Date: 2016/04/29 $
%% Properties

    %  unrestricted access
    properties (SetAccess = public) 
    end
    
    % access from class or subclasses
    properties (SetAccess = protected) 
        data_           % Input image
        imagesResults_  % Output image
    end
    
    % access by class members only (not from subclasses)
    properties (SetAccess = private) 
    end
%% Methods

    methods (Access = public)
        % constructor        
        function h = ClassBaseFilter
        end               
    end

    methods(Abstract=true, Access = public)
        % The process is abstract. It will be determined in subclasses
        Process(h);    
    end

    methods (Access = public)
        % Set the input image
        function SetInputImage(h,data)
            h.data_ = data;
        end
        % Get the output image
        function imagesResult = GetResult(h)
            imagesResult = h.imagesResults_;
        end
    end
end
