classdef ClassDilate < ClassBaseFilter
% ClassDilate   
%
%   author: Emmanuel Roux (emmanuel.roux@creatis.insa-lyon.fr)
%
%   Date: 2016/04/29 $
%% Properties

    %  unrestricted access
    properties (SetAccess = public) 
    end
    
    % access from class or subclasses
    properties (SetAccess = protected) 
    end
    
    % access by class members only (not from subclasses)
    properties (SetAccess = private) 
    end
    
%% Methods

    methods (Access = public)
       % Process is here a 3x3 square dilatation
       function Process(h)
        SE = strel('square',3);
        h.imagesResults_ = imdilate(h.data_,SE);
       end
       
   end
   
   
end
