classdef ClassFilterManager < ClassBaseFilter
% ClassFilterManager
%
%   author: Emmanuel Roux (emmanuel.roux@creatis.insa-lyon.fr)
%
%   Date: 2016/04/29 

%% Properties

    %  unrestricted access
    properties (SetAccess = public) 
    end
    
    % access from class or subclasses
    properties (SetAccess = protected) 
        list_filter; % The filter list
    end
    
    % access by class members only (not from subclasses)
    properties (SetAccess = private) 
    end
%% Methods

    methods (Access = public)
        % Definition of the filters list
        function h = ClassFilterManager
            h.list_filter{1} = ClassThresholdFilter;
            h.list_filter{2} = ClassDilate;
            h.list_filter{3} = ClassDilate;
            h.list_filter{4} = ClassErode;
        end
               
    end
    
    methods (Access = public)
       % Process execute the pipeline of processes in the list_filter
       function Process(h)
           h.list_filter{1}.SetInputImage(h.data_);
         for i=1:length(h.list_filter)-1
            h.list_filter{i}.Process;
            h.list_filter{i+1}.SetInputImage(h.list_filter{i}.GetResult);
         end
          h.list_filter{end}.Process;
          h.imagesResults_ = h.list_filter{end}.GetResult;
       end
       
   end
   
   
end
